---
title: RTCRtpSender
slug: Web/API/RTCRtpSender
tags:
  - API
  - Audio
  - DTLS
  - DTMF
  - Interface
  - Media
  - NeedsExample
  - RTCRtpSender
  - RTP
  - Reference
  - Video
  - WebRTC
  - WebRTC API
  - WebRTC Device API
---
<div>{{APIRef("WebRTC")}}</div>

<div id="interface_description">
<p><span class="seoSummary">The <strong><code>RTCRtpSender</code></strong> interface provides the ability to control and obtain details about how a particular {{domxref("MediaStreamTrack")}} is encoded and sent to a remote peer.</span> With it, you can configure the encoding used for the corresponding track, get information about the device's media capabilities, and so forth. You can also obtain access to an {{domxref("RTCDTMFSender")}} which can be used to send {{Glossary("DTMF")}} codes (to simulate the user pressing buttons on a telephone's dial pad) to the remote peer.</p>
</div>

<h2 id="Properties">Properties</h2>

<dl id="property_definitions">
 <dt>{{domxref("RTCRtpSender.dtmf")}} {{ReadOnlyInline}}</dt>
 <dd>An {{domxref("RTCDTMFSender")}} which can be used to send {{Glossary("DTMF")}} tones using <code>telephone-event</code> payloads on the {{Glossary("RTP")}} session represented by the <code>RTCRtpSender</code> object. If <code>null</code>, the track and/or the connection doesn't support DTMF. Only audio tracks can support DTMF.</dd>
 <dt>{{domxref("RTCRtpSender.track")}} {{ReadOnlyInline}}</dt>
 <dd>The {{domxref("MediaStreamTrack")}} which is being handled by the <code>RTCRtpSender</code>. If <code>track</code> is <code>null</code>, the <code>RTCRtpSender</code> doesn't transmit anything.</dd>
 <dt>{{domxref("RTCRtpSender.transport")}} {{ReadOnlyInline}}</dt>
 <dd>The {{domxref("RTCDtlsTransport")}} over which the sender is exchanging the RTP and RTCP packets used to manage transmission of media and control data. This value is <code>null</code> until the transport is established. When bundling is in use, more than transceiver may be sharing the same transport object.</dd>
</dl>

<h3 id="Obsolete_properties">Obsolete properties</h3>

<dl>
 <dt><code>rtcpTransport</code> {{obsolete_inline}}</dt>
 <dd>This property has been removed; the RTP and RTCP transports have been combined into a single transport. Use the {{domxref("RTCRtpSender.transport", "transport")}} property instead.</dd>
</dl>

<h2 id="methods">Methods</h2>

<dl id="method_definitions">
 <dt>{{domxref("RTCRtpSender.getParameters()")}}</dt>
 <dd>Returns a {{domxref("RTCRtpParameters")}} object describing the current configuration for the encoding and transmission of media on the <code>track</code>.</dd>
 <dt>{{domxref("RTCRtpSender.getStats()")}}</dt>
 <dd>Returns a {{jsxref("Promise")}} which is fulfilled with a {{domxref("RTCStatsReport")}} which provides statistics data for all outbound streams being sent using this <code>RTCRtpSender</code>.</dd>
 <dt>{{domxref("RTCRtpSender.setParameters()")}}</dt>
 <dd>Applies changes to parameters which configure how the <code>track</code> is encoded and transmitted to the remote peer.</dd>
 <dt>{{domxref("RTCRtpSender.setStreams()")}}</dt>
 <dd>Sets the {{domxref("MediaStream")}}(s) associated with the {{domxref("RTCRtpSender.track", "track")}} being transmitted by this sender.</dd>
 <dt>{{domxref("RTCRtpSender.replaceTrack()")}}</dt>
 <dd>Attempts to replace the track currently being sent by the <code>RTCRtpSender</code> with another track, without performing renegotiation. This method can be used, for example, to toggle between the front- and rear-facing cameras on a device.</dd>
</dl>

<h2 id="Static_methods">Static methods</h2>

<dl id="method_definitions_obsolete">
 <dt>{{domxref("RTCRtpSender.getCapabilities()")}}</dt>
 <dd>Returns an {{domxref("RTCRtpCapabilities")}} object describing the system's capabilities for sending a specified kind of media data.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("WebRTC 1.0", "#rtcrtpsender-interface", "RTCRtpSender")}}</td>
   <td>{{Spec2("WebRTC 1.0")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.RTCRtpSender")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>WebRTC API</li>
 <li>{{domxref("RTCPeerConnection.addTrack()")}}</li>
 <li>{{domxref("RTCPeerConnection.getSenders()")}}</li>
 <li>{{domxref("RTCRtpReceiver")}}</li>
</ul>
